package de.tudarmstadt.maki.simonstrator.api.component.vehicular.api;

import de.tudarmstadt.maki.simonstrator.api.component.sensor.location.Location;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkLink;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.trafficlights.TrafficLight;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.trafficlights.TrafficLightState;
import de.tudresden.ws.container.SumoTLSController;
import de.tudresden.ws.container.SumoTLSProgram;

import java.util.List;
import java.util.Map;

/**
 * 
 * @author Tobias Meuser (tobias.meuser@kom.tu-darmstadt.de)
 * @version 1.0 at 06.11.2017
 *
 */
public interface TrafficLightController extends SUMOController {
	List<TrafficLight> getAllTrafficLights();

	List<String> getControlledLanes(String pTrafficLightID);
	List<String> getControlledEdges(String pTrafficLightID);

	Map<RoadNetworkLink, TrafficLightState> getTrafficLightStateForEachLane(String pTrafficLightID);

	boolean nextStep();
	double getStep();
	double getStart();

	List<Location> getAllIntersections(boolean b);

    int getPhase(String trafficLightId);
	void setPhase(String trafficLightId, int phase);
    long getRemainingPhaseTime(String trafficLightId);
	void setPhaseDuration(String trafficLightId, int extraTime);
	void setPhaseDuration(String trafficLightId, double extraTime);
	double getPhaseDuration(String trafficLightId);
	int getProgramId(String trafficLightId);
	String getDefinition(String trafficLightId);
    SumoTLSController getCompleteDefinition(String trafficLightId);


	int getLastStepVehicleNumber(String laneIdFrom);
    List<String> getLastStepVehicleIDs(String laneId);
	double getVehicleSpeed(String vehicleId);
	Location getVehiclePosition(String vehicleId);
	double getVehicleMaxSpeed(String vehicleId);

    int getEdgeOccupancyRate(String edgeIdFrom);

    void setCompleteRedYellowGreenDefinition(String trafficLightId, SumoTLSProgram sumoTLSProgram);

    boolean isValidTrafficLightId(String nextTL);

	double getRoadLength(String trafficLightId, String roadId);

    double getVehicleAcceleration(String vehicleId);
}

