/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork;

public class RoadNetworkLink {
	private String _from;
	private String _to;

	public RoadNetworkLink(String pFrom, String pTo) {
		_from = pFrom;
		_to = pTo;
	}

	public String getFrom() {
		return _from;
	}

	public void setFrom(String pFrom) {
		_from = pFrom;
	}

	public String getTo() {
		return _to;
	}

	public void setTo(String pTo) {
		_to = pTo;
	}

	@Override
	public int hashCode() {
		return _from.hashCode() + _to.hashCode();
	}

	@Override
	public boolean equals(Object pObj) {
		if (pObj instanceof RoadNetworkLink) {
			RoadNetworkLink link = (RoadNetworkLink) pObj;
			return link._to.equals(_to) && link._from.equals(_from);
		}
		return super.equals(pObj);
	}
}
