/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 *
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.trafficlights;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import de.tudarmstadt.maki.simonstrator.api.component.sensor.location.Location;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.api.TrafficLightController;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkEdge;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkLink;

public class TrafficLight {

    private String _trafficLightId;
    private Location trafficLightLocation;
    //private HashMap<String, Integer> _vehicleRate;

    private TrafficLightController _trafficLightController;

    public TrafficLight(String pTrafficLightId, TrafficLightController pTrafficLightController) {
        _trafficLightId = pTrafficLightId;
        _trafficLightController = pTrafficLightController;
        //init vehicleRate
        /*
        List<String> controlledEdges = _trafficLightController.getControlledEdges(pTrafficLightId);
        for (String edge : controlledEdges) {
            _vehicleRate.put(edge, 0);
        }
        */
    }

    public List<String> getControlledLaneIDs() {
        return _trafficLightController.getControlledLanes(_trafficLightId);
    }

    public Map<RoadNetworkLink, TrafficLightState> getTrafficLightStateForEachLane() {
        return _trafficLightController.getTrafficLightStateForEachLane(_trafficLightId);
    }

    public String getTrafficLightId() {
        return _trafficLightId;
    }
}
