package de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.trafficlights;

import de.tudarmstadt.maki.simonstrator.api.component.HostComponent;
import de.tudarmstadt.maki.simonstrator.api.component.sensor.location.Location;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetwork;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkLink;
import de.tudresden.ws.container.SumoTLSController;
import de.tudresden.ws.container.SumoTLSProgram;

import java.util.List;
import java.util.Map;

public interface TrafficLightInformationComponent extends HostComponent {
    void setTrafficLightId(String pTrafficLightId);
    void resetTrafficLightId();

    boolean isValid();

    Location getTrafficLightLocation();
    String getTrafficLightId();
    List<String> getControlledLanes(String pTrafficLightId);
    List<String> getControlledEdges(String pTrafficLightId);

    Map<RoadNetworkLink,TrafficLightState> getTrafficLightStateForEachLane();

    //Deprecated
    int getPhase(String pTrafficLightId);
    void setPhase(String pTrafficLightId, int phase);

    int getPhase();
    void setPhase(int phase);

    long getRemainingPhaseTime();
    void setPhaseDuration(String trafficLightId, int extraTime);
    double getPhaseDuration(String trafficLightId);

    int getProgramId();
    String getDefinition();
    int getLastStepVehicleNumber(String edgeIdFrom);
    SumoTLSController getCompleteDefinition();
    List<String> getLastStepVehicleIDs(String laneId);
    double getVehicleSpeed(String vehicleId);
    Location getVehiclePosition(String vehicleId);

    double getVehicleMaxSpeed(String vehicleId);

    int getMinExpectedNumber();

    int getEdgeOccupancyRate(String edgeIdFrom);

    void setCompleteRedYellowGreenDefinition(String trafficLightId, SumoTLSProgram sumoTLSProgram);

    boolean isValidTrafficLightId(String nextTL);

    double getRoadLength(String roadId);

    void setPhaseDuration(double timeExtension);

    double getVehicleAcceleration(String vehicleId);
}